import sys
import java.io as io
#import os

from de.hu_berlin.german.korpling.saltnpepper.salt import SaltFactory
from de.hu_berlin.german.korpling.saltnpepper.salt.saltCommon import SaltCommonFactory
from de.hu_berlin.german.korpling.saltnpepper.pepperModules.pythonModules import PythonImporter
from de.hu_berlin.german.korpling.saltnpepper.pepper.pepperModules import FormatDefinition
from de.hu_berlin.german.korpling.saltnpepper.pepper.pepperModules import CorpusDefinition
from de.hu_berlin.german.korpling.saltnpepper.pepper.pepperModules import PepperInterfaceFactory
from org.eclipse.emf.common.util import URI

documentMap={}

class PythonImporter():
	
    pythonImporter=0
	corpusGraphToGet=0
	corpusPath=0
	name = "SamplePyImporter"
	formatName = "PythonSample"
	formatVersion = "0.1"
	
	def __init__(self):
		print "Loading Python importer Module from: \n "#, os.path.abspath(__file__)
	
	def getCorpusPath(self):
		return self.pythonImporter.getCorpusDefinition().getCorpusPath()
		
	def setCorpusPath(self, path):
		self.pythonImporter.getCorpusDefinition().setCorpusPath(URI.createFileURI(path))
	
	def getName(self):
		return self.name
	
	def getFormatDef(self):
		formDef = PepperInterfaceFactory.eINSTANCE.createFormatDefinition()
		formDef.setFormatName(self.formatName)
		formDef.setFormatVersion(self.formatVersion)
		return formDef
	
	def setCorpusDefinition(self):
		corpDef= PepperInterfaceFactory.eINSTANCE.createCorpusDefinition()
		corpDef.setFormatDefinition(self.getFormatDef())
		corpDef.setCorpusPath(self.getCorpusPath())
		self.pythonImporter.setCorpusDefinition(corpDef)
	
	def PythonImporter(self, PyImporter):
		print "Constructor: called by ", PyImporter.getSymbolicName()
		self.pythonImporter = PyImporter
		self.corpusPath = self.getCorpusPath()
		print "Constructor: Setting Corpus Definition"
		self.setCorpusDefinition()
		print "Constructor: " , self.corpusPath.toFileString()
		
	def importCorpusStructure(self,corpusGraph):
		"""This method is called by Pepper at the start of conversion process. 
		It shall create the structure the corpus to import. That means creating all necessary SCorpus, 
		SDocument and all Relation-objects between them. The path tp the corpus to import is given by
		this.getCorpusDefinition().getCorpusPath().
		@param self ...
		@param corpusGraph an empty graph given by Pepper, which shall contains the corpus structure"""
		# set corpus graph information
		sElementId = SaltFactory.eINSTANCE.createSElementId()
		sElementId.setId("salt://PyTestCorpusGraph")
		corpusGraph.setSElementId(sElementId)
		corpusGraph.setSName("PyTestCorpusGraph")
		corpusGraph.setSElementId(sElementId)
		# create corpus and set the corpus attributer
		corpus1 = SaltFactory.eINSTANCE.createSCorpus()
		corpus1.setSId(corpusGraph.getSId()+"/corp1")
		corpus1.setSName("TestCorpus")
		corpusGraph.addSNode(corpus1)
		print "searching documents in corp path: ", self.corpusPath
		for file in  io.File(self.corpusPath.toFileString()).listFiles(): 
			if file.isDirectory() and not file.getName() == ".svn":
				print "found document ", file.getName()
				# create document, set the attributes and add it to the corpus graph
				document = SaltFactory.eINSTANCE.createSDocument()
				document.setSName(file.getName())
				document.setSId(corpus1.getSId()+"/"+document.getSName())
				document.setSDocumentGraph(SaltFactory.eINSTANCE.createSDocumentGraph());
				document.getSDocumentGraph().setSId(document.getSId()+"/corpusPlain");
				corpusGraph.addSDocument(corpus1,document)
				documentMap[document.getSId()] = file.getAbsolutePath()
				print "created Document " , document.getSName(), document.getSId()
		print "corpus name: ", corpus1.getSName()
		corpusGraphToGet = corpusGraph
		return corpusGraph
		
	def start(self, document):
		print "importing document ", document.getSId()
		print "Path: ", documentMap[document.getSId()]
		sTextualDS= SaltFactory.eINSTANCE.createSTextualDS()
		sTextualDS.setSName("Text-Datasource1")
		sTextualDS.setSId(document.getSId()+"#"+sTextualDS.getSName())
		document.getSDocumentGraph().addSNode(sTextualDS)
		textFile = documentMap[document.getSId()]+'/doc1.text' 
		textFileHandle = open(textFile,'r')
		text = textFileHandle.read()
		document.getSDocumentGraph().getSTextualDSs().get(0).setSText(text)
		return document.getSDocumentGraph()
